
import java.util.ArrayList;

/**
 * 
 * @author Sarah Becker und Maximilian Edich
 *
 */
public class Main {
	
	private static ArrayList<String> words;
	private static String alphabet;
	private static int size;

	public static void main(String[] args) {
		//Erstelle Wortliste
		words = new ArrayList<String>();
	
		
		alphabet = args[0];
                size = Integer.parseInt(args[1]);
		//Eigentliche Funktion
		bands(alphabet, size);
		
		System.out.println(words);
	}
	
	/**
	 * Ruft addWords(String, int, String) auf, welche rekursiv definiert ist.
	 * @param a Alphabet
	 * @param pSize Wortlaenge
	 */
	private static void bands(String a, int pSize){
		addWords(a, pSize, "");
	}
	
	/**
	 * Loescht Buchstaben, welche mehrfach im Alphabet vorkommen.
	 */
	private static String getAlphabet(String s){
		String lAlpha = "";
		for (int i = 0; i < s.length(); i++) {
			if(!lAlpha.contains("" + s.charAt(i))){
				lAlpha = lAlpha + s.charAt(i);
			}
		}
		return lAlpha;
	}
	
	/**
	 * Fuegt Woerter zur Wortliste hinzu. Dabei geht die Funktion rekursiv vor, falls das berechnete Teilwort noch nicht der 
	 * gewuenschten Laenge entspricht.
	 */
	private static void addWords(String a, int size, String word){
		if(word.length() < size){
			for (int i = 0; i < a.length(); i++) {
				//Ergaenze das Teilwort um ein Zeichen aus dem Alphabet.
				//dabei entstehen n Teilworte, mit n = Laenge des Alphabets.
				addWords(a, size, word + a.charAt(i));
			}
		}else{ //Wenn das Teilwort lang genug ist
			if(!words.contains(reverseString(word))){ //Falls keine gespiegelte Kopie vorhanden
				words.add(word);
			}
		}
	}
	
	/**
	 * Gibt einen gespiegelten String wieder.
	 */
	private static String reverseString(String s){
		String revS = "";
		for (int i = 0; i < s.length(); i++) {
			revS = s.charAt(i) + revS;
		}
		
		return revS;
	}
}
