import System.Environment
-- Basiert auf der Lösung von Ruth Rothgänger und Michel Henrichs

-- wrds letters n
-- listet alle Worte der Länge n in letters auf
-- die Reihenfolge ist lexikographisch bezüglich der von letters induzierten Ordnung
wrds :: [ a ] -> Int -> [[ a ]]
wrds letters 0 = [[]]
wrds letters n = [ y:x | y <- letters, x <- (wrds letters (n - 1))]

-- noReverse lst
-- entfernt aus lst alle Vorkommnisse von (reverse x) sobald x vorkommt
noReverse :: (Eq a) => [[a]] -> [[a]]
noReverse []     = []
noReverse (x:xs) = (x : noReverse (filter (/= (reverse x)) xs))

-- bands letters n
-- listet alle lexikographisch minimalen Repräsentanten von Bändern auf
bands :: (Eq a) => [a] -> Int -> [[a]]
bands letters n = (noReverse (wrds letters n))

main :: IO()
main = do
    args <- getArgs
    let letters:nstr:_ = args
    let n = read nstr :: Int
    print (bands letters n)
